function [] = BEATz_analysis(SMoo)
%BEATz analysis 18/06/2012 
%% import variables from base workspace
Sam2hash = evalin('base', 'Sam2hash');
Sfreq = evalin('base', 'Sfreq');
TR = evalin('base', 'TR');
fileName = evalin('base', 'fileName');
nScans = evalin('base', 'nScans');
pathName = evalin('base', 'pathName');
dummyScans = evalin('base', 'dummyScans');
Up=Sfreq*1.5;
Low=Sfreq*.5;

%% import .puls physiological file and get the correct values
RawerData=importdata(strcat(pathName,fileName),' ', Sam2hash);
Fin = length(RawerData.data);
Stt = Fin -(Sfreq*TR*nScans);
%{
if (isfloat(RawerData)==1)
    Beats=RawerData;%already spliced Start to finish
else
    Beats=RawerData.data(Stt+1:Fin);
end
%}
Beats=RawerData.data(Stt:Fin,5);

%% Preamble
pStruct.rawData=Beats;
sSeq=TR:TR:(nScans*TR);
sIdxs=1:nScans;

%% %Cleaning from artifactual spikes
pulsData=pStruct.rawData;
%pulsData(pulsData==5000)=pulsData(find(pulsData==5000)+1);
pStruct.pulsData=pulsData;

%% smooth data
[spulse, desvabs] = HodPres_filter(pulsData,SMoo);
%spulse = round(pulsData);
%spulse = round(spulse);
pStruct.unsmoothed=pulsData;
pStruct.pulsData = spulse;
pulsData = spulse;
%% Seeking the events

[pks,allIdxs] = findpeaks(pulsData);
rawEvTime = allIdxs(zscore(pulsData(allIdxs))>0);
pStruct.rawEvTime = rawEvTime;


%% Seeking the misses
%{
badIdxs=rawEvTime(find((diff(rawEvTime))<20 | (diff(rawEvTime))>60));
badIdxs=rawEvTime(find(diff(rawEvTime))>60);

%%
if length(badIdxs)>0

    pStruct.badIdxs=badIdxs;
    evTime=zeros(length(rawEvTime)+length(badIdxs),1);

    for i=1:length(badIdxs)

        repIdxs(i,1)=badIdxs(i)+1;
        repIdxs(i,2)=rawEvTime(find(rawEvTime==badIdxs(i))+1);

        tmpChunk=pulsData((repIdxs(i,1)+5):(repIdxs(i,2)-5));
        tmpMax=find(tmpChunk==max(tmpChunk),1);

        newEvent(i)=tmpMax+repIdxs(i,1)+5;
        tmpIdxs=find(rawEvTime<newEvent(i));
        tmpIdx(i)=tmpIdxs(end);

    end

    pStruct.newEvent=newEvent;
    pStruct.tmpIdx=tmpIdx;

    evTime(1:tmpIdx(1))=rawEvTime(1:tmpIdx(1));
    evTime(tmpIdx(1)+1)=newEvent(1);
    i=1;
    if length(badIdxs)>1
        for i=2:length(newEvent)

            evTime((tmpIdx(i-1)+i):tmpIdx(i)+1)=rawEvTime((tmpIdx(i-1)+1):tmpIdx(i));
            evTime(tmpIdx(i)+i)=newEvent(i);
            n=500;

        end

        evTime((tmpIdx(end)+i+1):end)=rawEvTime((tmpIdx(end)+i-1):end);
        
    else
        evTime((tmpIdx(end)+i+1):end)=rawEvTime((tmpIdx(end)+i):end);
    end
    
else
%}
evTime=rawEvTime;
%}
%% First plot
assignin('base', 'pulsData', pulsData)
figure,plot(pulsData)
hold on
pvTime = pulsData(evTime);
plot(evTime,pvTime,'r*')

%% delete
[del_points new_dataset] = BEATz_delete(evTime, pvTime);
pStruct.del_points = del_points;
pStruct.new_dataset = new_dataset;

%% Diff and threshold
evTime = new_dataset(:,1);
pStruct.evTime = evTime;
rHRV = diff(evTime);
pStruct.rHRV = rHRV;
a = find(rHRV > Low & rHRV < Up);
tHRV = rHRV(a);
pStruct.tHRV = tHRV;
mHRV = 1000*(std(tHRV)/Sfreq);
MHRVdisp=sprintf('mean HRV (std) for %s = %f ms',fileName, mHRV);
disp(MHRVdisp)
pStruct.mHRV = mHRV;
tEvtime = evTime(a);
pStruct.tEvtime = tEvtime;
%figure(5)
%plot(tHRV)

%% BPM
Nbeatz=length(new_dataset);
gtUpTime= rHRV>Up;
removetime=(sum(rHRV(gtUpTime)))/Sfreq;
TotalTime=(TR*nScans)-removetime;
BPM=(Nbeatz/TotalTime)*60;
pStruct.BPM = BPM;
BPMdisp=sprintf('Mean BPM for %s = %f beats',fileName, BPM);
disp(BPMdisp)

%% save
format short
outFileName=fileName;
strPuls=strfind(fileName,'.puls');
outFileName(strPuls:end)=[];
dlmwrite([strcat(pathName,outFileName),'.BPM'],BPM,'%f');
dlmwrite([strcat(pathName,outFileName),'.mHRV'],mHRV,'%f');
save([strcat(pathName,outFileName),'.pStruct.mat'],'pStruct');
%end