%Interactively select and delete points from an existing plot

function [del_points new_dataset] = BEATz_delete(varargin)

% Modified from sel_and_del:
%   Author: Jos-Luis Guerrero
%   e-mail address: jose-luis.guerrero@hyd.uu.se
%   Matlab version: 7.5.0(2007b)
%   Release: 0.9
%   Release date: 25/08/09
% by Ben Davis for BEATz

pulsData = evalin('base', 'pulsData');
new_plot = 'yes';
x = cell2mat(varargin(1));
y = cell2mat(varargin(2));
f = 3;
Axe = axis(gca);
figure(f);
a = gca;
%Cleaning space for application defined data
if isappdata(f,'Deleted_points');
    rmappdata(f,'Deleted_points');
end
if isappdata(f,'New_dataset');
    rmappdata(f,'New_dataset');
end

%Plotting for the points to be edited
hold on
axis(Axe);
pH=plot(a,x,y,'ro');
%Turning it off in case of a scatterplot
hold off
set(pH,'HitTest','off');
disp('Press any key while cursor is over the selection window to accept selection')
first_born=allchild(a);
new_fig=2;
%Defining callbacks
set(a,'ButtonDownFcn',{@select_point,first_born,new_plot,new_fig})  %Passing points to be edited
set(f,'KeyPressFcn',@stop_select);     %Stopping the editing


%Waiting for the callbacks to be executed and extracting new datasets from
%the application data
uiwait(f)
if isappdata(f,'Deleted_points')
    del_points=getappdata(f,'Deleted_points');
end
if isappdata(f,'New_dataset');
    new_dataset=getappdata(f,'New_dataset');
end
close(2,3)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    function select_point(varargin)
        %Specifying what happens with every mouse click
        drawnow
        n_arg = length(varargin);
        for o = 1:n_arg
            if ischar(varargin{o})
                newplot = varargin{o};
            end
        end
        new_fig=cell2mat(varargin(5));
        test=[];idx2=[];
        click_type=get(f,'SelectionType');
        first_born=cell2mat(varargin(3)); %Original dataset
        pt = get(a,'CurrentPoint'); %Getting click position
        xp=get(pH,'Xdata'); %Getiing coordinates of points to be edited
        yp=get(pH,'Ydata');
        dx=daspect(a);      %Aspect ratio is needed to compensate for uneven axis when calculating the distance
        dista=sqrt (((pt(1,1)-xp).*dx(2)).^2+((pt(1,2)-yp).*dx(1)).^2);
        idx=find(dista == min(dista),1,'first'); %Getting point closest to the click
        test=get(f,'UserData');
       
        %Specifying what happens depending whether there is a right or left
        %click
        if isempty(test);
            if strcmp(click_type,'normal')
                hold on
                plot(a,xp(idx),yp(idx),'ks','MarkerFaceColor','k');
                hold off
                new_children(new_plot,new_fig);
            elseif strcmp(click_type,'alt')
                set(f,'UserData',[]);
                new_children(new_plot,new_fig);
            end
        elseif ~isempty(test)
            [exists idx2]=get_coord;
            if strcmp(click_type,'normal')
                if exists
                    new_children(new_plot,new_fig);
                elseif ~exists
                    hold on
                    plot(a,xp(idx),yp(idx),'ks','MarkerFaceColor','k');
                    hold off
                    new_children(new_plot,new_fig);
                end
            elseif strcmp(click_type,'alt')
                if exists
                    del_handle = test(idx2);
                    delete(del_handle);
                    new_children(new_plot,new_fig);
                elseif ~exists
                    new_children(new_plot,new_fig);
                end
            end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%     
        function new_children(new_plot,new_fig)
            %Getting points which have been selected by comparing to the
            %original dataset, plotting new dataset if required
            clear options
            a_new=[];
           
            %Saving clicked points
            all_children=allchild(a);
            new_children=all_children(~ismember(all_children,first_born));
            set(new_children,'HitTest','off');
            set(f,'UserData',new_children);
            
            %Plotting if required
            if strcmp(new_plot,'yes');
                new_test=get(f,'UserData');
                figure(new_fig);
                %Deleting old axes
                delete(findobj(new_fig,'Type','axes'));
                a_new = copyobj(a,new_fig);
                %Copying plot properties from points being edited
                adoptive_child = allchild(a);
                options=get(adoptive_child(end));
                             
               %Obtaining data to plot
                if ~isempty(new_test)
                    for p=1:length(new_test);
                        nres_x(p)=get(new_test(p),'Xdata');
                        nres_y(p)=get(new_test(p),'Ydata');
                    end
                to_del=[nres_x' nres_y'];
                
%Debug                
[whatthe,fuck] = size(x);
if fuck > 1;
    x = x'
end
                old_dataset=[x y];
                [junk del_idx] = ismember([x y],to_del,'rows');
                new_dataset=old_dataset(~del_idx,:);
                else
                    new_dataset = [x y];
                end
                    plot(a_new,new_dataset(:,1),new_dataset(:,2),...
                    'LineStyle',options.LineStyle,...
                    'LineWidth',options.LineWidth,...
                    'Marker',options.Marker,...
                    'MarkerSize',options.MarkerSize,...
                    'MarkerEdgeColor',options.MarkerEdgeColor,...
                    'MarkerFaceColor',options.MarkerFaceColor,...
                    'Color',options.Color);
                    set(a_new,'Xlim',get(a,'Xlim'),...
                    'Ylim',get(a,'Ylim'));
                hold on
                plot(pulsData)
                hold off
                end
            figure(f);
            linkaxes([gca(2) gca(3)],'xy')
        end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        function [exists idx2 all_data] = get_coord
            %Checking if any point has been selected with the mouse click
            test=[]; all_data=[]; m = []; exists=[]; idx2=[];
            test = get(f,'UserData');
            for m=1:length(test);
                    res_x(m)=get(test(m),'Xdata');
                    res_y(m)=get(test(m),'Ydata');
            end
            coord=[xp(idx) yp(idx)];
            all_data = [res_x' res_y'];
            [exists idx2] = ismember(coord,all_data,'rows');   
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
       function stop_select(varargin)
        %Saving modified data in the figure once it has been selected
        set(a,'ButtonDownFcn','');
        point_handles=get(f,'UserData');
        if ~isempty(point_handles)
            for o=1:length(point_handles);
                res_x(o)=get(point_handles(o),'Xdata');
                res_y(o)=get(point_handles(o),'Ydata');
            end
            to_del=[res_x' res_y'];
            old_dataset=[x y];
            [junk del_idx] = ismember([x y],to_del,'rows');
            new_dataset=old_dataset(~del_idx,:);
            setappdata(f,'Deleted_points',to_del);
            setappdata(f,'New_dataset',new_dataset);
            figure(f)
            uiresume(f)
        else
            setappdata(f,'Deleted_points',[]);
            setappdata(f,'New_dataset',[x y]);
            uiresume(f)
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%            
   
end