function [] = BEATz_input()
% Input Parameters for BEATz_input.  

S.fh = figure('units','pixels',...
              'position',[300 300 300 300],...
              'menubar','none',...
              'name','BEATz',...
              'numbertitle','off',...
              'resize','off');
          
S.tx1 = uicontrol('style','tex',...
                 'unit','pix',...
                 'position',[1 260 60 30],...
                 'backgroundcolor',get(S.fh,'color'),...
                 'fontsize',12,'fontweight','bold',... 
                 'string','TR = ');

S.TR = uicontrol('style','edit',...
                 'unit','pix',...
                 'position',[50 265 60 30],...
                 'fontsize',14,...
                 'string',evalin('base', 'TR'));
             
S.tx2 = uicontrol('style','tex',...
                 'unit','pix',...
                 'position',[130 210 100 80],...
                 'backgroundcolor',get(S.fh,'color'),...
                 'fontsize',12,'fontweight','bold',... 
                 'string','# of Scans =');
             
S.nS = uicontrol('style','edit',...
                 'unit','pix',...
                 'position',[230 265 60 30],...
                 'fontsize',14,...
                 'string',evalin('base', 'nScans'));

S.tx3 = uicontrol('style','tex',...
                 'unit','pix',...
                 'position',[3 195 230 60],...
                 'backgroundcolor',get(S.fh,'color'),...
                 'fontsize',12,'fontweight','bold',... 
                 'string','Sampling Frequency in Hz =');
             
S.Sf = uicontrol('style','edit',...
                 'unit','pix',...
                 'position',[230 229 60 30],...
                 'fontsize',14,...
                 'string',evalin('base', 'Sfreq'));
             
S.tx4 = uicontrol('style','tex',...
                 'unit','pix',...
                 'position',[3 155 230 60],...
                 'backgroundcolor',get(S.fh,'color'),...
                 'fontsize',12,'fontweight','bold',... 
                 'string','How many lines untill # ?');
             
S.Sec = uicontrol('style','edit',...
                 'unit','pix',...
                 'position',[230 190 60 30],...
                 'fontsize',14,...
                 'string',evalin('base', 'Sam2hash'));
             
S.tx5 = uicontrol('style','tex',...
                 'unit','pix',...
                 'position',[12 110 180 60],...
                 'backgroundcolor',get(S.fh,'color'),...
                 'fontsize',12,'fontweight','bold',... 
                 'string','Smoothing Parameter =');
             
S.SMoo = uicontrol('style','edit',...
                 'units','pix',...
                 'position',[200 145 90 30],...
                 'fontsize',14,...
                 'string',evalin('base', 'SMoo'));
             
S.In = uicontrol('style','edit',...
                 'unit','pix',...
                 'position',[10 100 280 30],...
                 'fontsize',14,...
                 'string',evalin('base', 'fileName'));
             
S.nf = uicontrol('style','push',...
                 'units','pix',...
                 'position',[10 50 280 40],...
                 'fontsize',20,...
                 'string','Select New .puls File',...
                 'callback',{@Nf,S});
             
S.pb = uicontrol('style','push',...
                 'units','pix',...
                 'position',[10 5 280 40],...
                 'fontsize',20,...
                 'string','Analyse',...
                 'callback',{@Analyse,S});
             

             
%{             
S.pb = uicontrol('style','push',...
                 'units','pix',...
                 'position',[1 135 100 40],...
                 'fontsize',12,...
                 'string','Clean',...
                 'callback',{@CLEAN,S});
%}
                 
function [] = Analyse(varargin)
S = varargin{3};  % Get the structure.
assignin('base', 'fileName', get(S.In,'string'))
assignin('base', 'Sam2hash', str2num(get(S.Sec,'string')))
assignin('base', 'Sfreq', str2num(get(S.Sf,'string')))
assignin('base', 'nScans', str2num(get(S.nS,'string')))
assignin('base', 'TR', str2num(get(S.TR,'string')))
assignin('base', 'SMoo', str2num(get(S.SMoo,'string')))
SMoo = str2num(get(S.SMoo,'string'));
BEATz_analysis(SMoo)

function [] = Nf(varargin)
S = varargin{3};
[fileName, pathName] = uigetfile('*.log','Select .puls file');
set(S.In,'string',fileName);
assignin('base', 'pathName', pathName)
%function [] = CLEAN(varargin)